Subject: Re: [PATCH] select appropriate skb size in tcp_sendmsg when TSO is used

From: Jeff Garzik <[email-masked]>
Date: Thu, 28 Oct 2004 00:16:33 -0400

David S. Miller wrote:
> On Wed, 27 Oct 2004 10:22:09 +1000
> Herbert Xu <[email-masked]> wrote:
> 
> 
>>On Tue, Oct 26, 2004 at 08:15:31PM -0400, Jeff Garzik wrote:
>>
>>>>IMHO it is valid to disable SG without disabling checksums, no?
>>>
>>>It's useless:  The packet header is always in a separate memory
>>>location from the packet data, when using zerocopy sendfile(2).
>>>
>>>When not using zerocopy sendfile, you are copying the data _anyway_.
>>
>>I'm fine with adding this check.  However I think that belongs in
>>another patch since we don't check that in register_netdev currently.
>>
>>Dave, what do you think?
> 
> 
> I believe that allowing TX csum support without SG _is_
> useful even though it is not _effective_.
> 
> It is quite desirable for a driver author to be able to
> test out his TX csum offload support first, then add
> SG support next.  Similarly, if a driver author suspects
> some issues with either SG or TX csum support, he can
> better isolate the problem if we allow this.
> 
> Jeff do you agree?

<shrug>  it's never used that way in practice AFAIK, only used by 
confused sysadmins :)

I won't object if you preserve the behavior, but I still don't see much 
value in allowing it.

	Jeff